=== debian/changelog ===
mixminion (0.0.7~cvs) unreleased; urgency=low

  * - not release yet -
  * Add adduser to Depends:.

 -- Peter Palfrader <weasel@debian.org>  Thu, 15 Jan 2004 23:55:40 +0100

mixminion (0.0.6.2-1) experimental; urgency=low

  * Initial Release, uploading to experimental
    (Happy birthday #176539; closes: #176539).

 -- Peter Palfrader <weasel@debian.org>  Tue, 13 Jan 2004 16:01:20 +0100
